// components/myModal/myModal.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    // 弹窗宽度
    width: {
      type: String,
      value: "540rpx",
    },
    // 弹窗高度
    height: {
      type: String,
      value: "",
    },
    // 弹窗位置 默认center居中 left左侧 right右侧 top上侧 bottom下侧
    mode: {
      type: String,
      value: "center",
    },
    // 是否显示标题栏
    isShowHeader: {
      type: Boolean,
      value: true,
    },
    // 标题
    title: {
      type: String,
      value: "",
    },
    // 是否显示关闭图标
    isShowCloseIcon: {
      type: Boolean,
      value: true,
    },
    // 关闭图标Url
    closeIcon: {
      type: String,
      value: "../../imgs/common/close.png",
    },
    // 内容
    content: {
      type: String,
      value: "",
    },
    // 是否显示底部栏
    isShowFooter: {
      type: Boolean,
      value: false,
    },
    // 底部栏内容
    footer: {
      type: String,
      value: "",
    },
    // 是否显示遮罩层
    isShowMask: {
      type: Boolean,
      value: true,
    },
    // 是否允许点击遮罩层关闭
    maskClosable: {
      type: Boolean,
      value: true,
    },
  },

  /**
   * 组件的初始数据
   */
  data: {},

  /**
   * 组件的方法列表
   */
  methods: {
    // 点击遮罩层关闭弹窗
    handleClickMaskClose(e) {
      if (this.data.maskClosable) {
        const self = e.target.dataset.ref;
        if (self == "self") {
          this.triggerEvent("close");
        }
      }
    },
    // 点击关闭按钮关闭弹窗
    handleClickCloseBtn() {
      this.triggerEvent("close");
    },
    // 禁止页面触摸滑动 || 禁止点击穿透关闭
    catchtouchmove() {
      return;
    },
  },
});
