// components/searchInput/searchInput.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    // 是否为展示搜索栏
    isShow: {
      type: Boolean,
      value: false
    },
    // 输入框为空时占位符
    placeholder: {
      type: String,
      value: ""
    },
    // 是否自动获取焦点
    isFocus: {
      type: Boolean,
      value: false
    },
    // 搜索框的值
    inputValue: {
      type: String,
      value: "",
      observer: function (newVal, oldVal) {
        if (newVal) {
          this.setData({
            value: newVal
          })
        } else {
          this.setData({
            value: ""
          })
        }
      }
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    value: "" // 输入框的值
  },

  /**
   * 组件的方法列表
   */
  methods: {
    // 点击搜索框
    handleClickSearchBox() {
      this.triggerEvent("handleClickSearchInput");
    },

    // 输入框值发生改变
    handleInputChange(e) {
      let { value } = e.detail;
      this.setData({
        value: value
      });
      this.triggerEvent("handleSearchInputChange", value);
    }
  }
})
