export default class Poster {
    palette(posterArr) {
        if (posterArr && Array.isArray) {
            let canvasObj = {
                views: []
            };
            posterArr.forEach((val, i, arr) => {
                let {
                    elementId,
                    x,
                    y,
                    width,
                    height,
                    dataset
                } = val;
                let {
                    what,
                    uri
                } = dataset;
                if (what) {
                    what = what.toString();
                }
                switch (elementId) {
                    case 'container':
                        Object.assign(canvasObj, {
                            width: `${width}px`,
                            height: `${height}px`,
                            background: '#f5f5f5',
                            borderRadius: '0px'
                        });
                        break;
                    case 'posterInfo':
                        canvasObj.views.push({
                            type: 'rect',
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width}px`,
                                height: `${height}px`,
                                color: '#ffffff'
                            },
                        });
                        break
                    case 'imgBarcode':
                        canvasObj.views.push({
                            type: 'image',
                            url: uri || what,
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width}px`,
                                height: `${height}px`
                            }
                        });
                        break;
                    case 'picAvatarWrap':
                        canvasObj.views.push({
                            type: 'rect',
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width}px`,
                                height: `${height}px`,
                                borderRadius: `${height}px`,
                                color: '#ffffff'
                            },
                        });
                        break
                    case 'imgHead':
                        canvasObj.views.push({
                            type: 'image',
                            url: uri || what,
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width}px`,
                                height: `${height}px`,
                                borderRadius: `${height}px`
                            }
                        });
                        break;
                    case 'containerInner':
                        canvasObj.views.push({
                            type: 'rect',
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width}px`,
                                height: `${height}px`,
                                color: '#ffffff'
                            },
                        });
                        break;
                    case 'bottomWrap':
                        canvasObj.views.push({
                            type: 'rect',
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width}px`,
                                height: `${height}px`,
                                color: '#ffffff'
                            },
                        });
                        break;
                    case 'sourceDesc':
                        canvasObj.views.push({
                            type: 'text',
                            text: what,
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width + 5}px`,
                                fontSize: `32rpx`,
                                color: '#999'
                            }
                        });
                        break;

                    case 'sourceName':
                        canvasObj.views.push({
                            type: 'text',
                            text: what,
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width + 5}px`,
                                fontSize: `32rpx`,
                                color: '#000'
                            }
                        });
                        break;
                    case 'sourceTypeText':
                        canvasObj.views.push({
                            type: 'text',
                            text: what,
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width + 5}px`,
                                fontSize: `24rpx`,
                                color: '#000',
                            }
                        });
                        break;
                    case 'sourceType':
                        canvasObj.views.push({
                            type: 'rect',
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width}px`,
                                height: `${height}px`,
                                borderRadius: '22px',
                                background: "#FFE5E2",
                                color: "#FFE5E2",
                            },
                        });
                        break;
                    case 'title':
                        canvasObj.views.push({
                            type: 'text',
                            text: what,
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width + 20}px`,
                                fontSize: `28rpx`,
                                color: '#191919',
                            }
                        });
                        break;
                    case 'posteImg':
                        canvasObj.views.push({
                            type: 'image',
                            url: uri || what,
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width}px`,
                                height: `${height}px`,
                            }
                        });
                        break;
                    case 'slogan':
                        canvasObj.views.push({
                            type: 'image',
                            url: uri || what,
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width}px`,
                                height: `${height}px`,
                            }
                        });
                        break;
                    case "tips":
                        canvasObj.views.push({
                            type: 'text',
                            text: what,
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width}px`,
                                fontSize: `28rpx`,
                                color: '#191919',
                            }
                        });
                        break;
                    case "posterBottom":
                        canvasObj.views.push({
                            type: 'rect',
                            css: {
                                left: `${x}px`,
                                top: `${y}px`,
                                width: `${width}px`,
                                height: `${height}px`,
                                color: '#ffffff'
                            },
                        });
                        break

                    default:
                        break;
                }
            });
            return canvasObj;
        }
    }
}