const util = require('../../utils/util.js');
import Poster from './pattern.js'
Component({
  properties: {
    roleText: {
      type: String,
      value: ''
    },
    name: {
      type: String,
      value: ''
    },
    barcodeImgUrl: {
      type: String,
      value: ''
    },
    pattern: {
      type: String,
      value: ''
    },
    posterImg: {
      type: String,
      value: ''
    },
    isShowSourceUser: {
      type: Boolean,
      value: false
    },
    posterTitle: {
      type: String,
      value: ''
    },
    avatar: {
      type: String,
      value: ''
    },
  },
  data: {
    isChangeTag: false,
    slogan: "https://static.hoolihome.com/weapp/distributor/shareText.png",
    dataArr: [],
    template: null,
    isShowCanvas: false,
    canvasSrc: ""
  },
  methods: {
    getElementInfo: function () {
      const query = wx.createSelectorQuery().in(this);
      query.selectAll('.canvas-part').boundingClientRect((rects) => {
        let temArr = []
        rects.forEach((rect) => {
          let tmp = {
            elementId: rect.id,
            x: rect.left,
            y: rect.top,
            width: rect.width,
            height: rect.height,
            dataset: Object.assign({}, rect.dataset)
          };
          temArr.push(tmp)
        });
        let palette = new Poster().palette(temArr);
        this.setData({
          template: palette,
        })
      }).exec();
    },
    photoLoaded: function (e) {
      this.getElementInfo();
    },
    saveToAlbum() {
      wx.showLoading({
        title: '保存中'
      });
      this.setData({
        isShowCanvas: true
      })
      // let _this = this
      // wx.saveImageToPhotosAlbum({
      //   filePath: this.data.canvasSrc,
      //   success(res) {
      //     wx.showToast({
      //       title: '保存成功',
      //       icon: 'none',
      //       duration: 1000
      //     });
      //     _this.triggerEvent("hidePosterEvent")
      //   },
      //   fail() {
      //     wx.showModal({
      //       title: '授权失败',
      //       content: '是否打开小程序设置界面，完成对该小程序授权状态',
      //       success: function (res) {
      //         if (res.confirm) {
      //           wx.openSetting({
      //             success(res) { }
      //           })
      //         }
      //       }
      //     })
      //   }
      // })
    },
    cancelTap() {
      this.triggerEvent("hidePosterEvent")
    },
    onImgOK(e) {
      this.setData({
        canvasSrc: e.detail.path
      }, () => {
        this.setData({
          isShowCanvas: false,
        })
        wx.hideLoading()
        let _this = this
        wx.saveImageToPhotosAlbum({
          filePath: this.data.canvasSrc,
          success(res) {
            wx.showToast({
              title: '保存成功',
              icon: 'none',
              duration: 1000
            });
            _this.triggerEvent("hidePosterEvent")
          },
          fail() {
            wx.showModal({
              title: '授权失败',
              content: '是否打开小程序设置界面，完成对该小程序授权状态',
              success: function (res) {
                if (res.confirm) {
                  wx.openSetting({
                    success(res) { }
                  })
                }
              }
            })
          }
        })
      })
    },
    onImgErr(e) {
    },
    changeUser() {
      if (this.data.isChangeTag) {
        wx.navigateTo({
          url: `/pages/sourcePersonList/sourcePersonList?pattern=${this.data.pattern}&checkType=1`
        })
      }
    },
  }

})