const { api_index_info } = require("../../utils/api.js");
const { net } = require("../../utils/net.js");
const util = require("../../utils/util.js");

Page({
  data: {
    isShowPrivacyModal: false, // 是否显示隐私协议弹窗
    firstLoaidngFlag: true,
    showState: "1", // 当前登录状态 1未登录  2已登录
    userInfo: {},
    cardsArr: [
      {
        id: "1",
        icon: "icon-hooli-money",
        title: "客户",
        etitle: "Manage",
      },
      {
        id: "3",
        icon: "icon-hooli-orderx",
        title: "订单",
        etitle: "OrderManage",
      },
      {
        id: "4",
        icon: "icon-hooli-channelx",
        title: "团队",
        etitle: "Invitation",
      },
    ],
    pickerIndex: 4,
    list: [
      {
        name: "上周",
        value: "1",
      },
      {
        name: "本周",
        value: "2",
      },
      {
        name: "上月",
        value: "3",
      },
      {
        name: "本月",
        value: "4",
      },
      {
        name: "全部",
        value: "",
      },
    ],
    data: null,
  },
  onLoad: function (options) {
    let userInfo = util.getStorageSync("userInfo");
    if (userInfo && userInfo.token) {
      this.setData({
        showState: "2",
        userInfo: userInfo,
      });
    } else {
      // wx.reLaunch({
      //   url: '/pages/loginways/loginways',
      // });
    }
  },
  goLoginTap() {
    wx.reLaunch({
      url: "/pages/loginways/loginways",
    });
  },
  onShow: function () {
    if (this.data.showState == 2) {
      this.getWithData();
    }
    // 检测是否需要隐私协议授权
    this.isNeedPrivacyAuthorization();
  },
  // 检测是否需要隐私协议授权
  isNeedPrivacyAuthorization() {
    util
      .isNeedWxPrivacyAuthorization()
      .then((val) => {
        const isNeedStatus = val;
        if (isNeedStatus) {
          // 需要隐私协议授权
          // 显示弹窗
          this.setData({
            isShowPrivacyModal: true,
          });
        } else {
          // 不需要隐私协议授权
          // 不显示弹窗
          this.setData({
            isShowPrivacyModal: false,
          });
        }
      })
      .catch(() => {
        // 请求出错，不显示弹窗
        this.setData({
          isShowPrivacyModal: false,
        });
      });
  },
  // 隐私协议弹窗 - 点击同意后触发
  tapConfirmAction() {
    this.setData({
      isShowPrivacyModal: false,
    });
  },
  // 隐私协议弹窗 - 点击拒绝后触发
  tapRefuseAction() {
    this.setData({
      isShowPrivacyModal: false,
    });
  },
  // 获取数据简报数据
  getWithData() {
    this.setData({
      firstLoaidngFlag: true,
    });
    const { list, pickerIndex } = this.data;
    let params = {};
    params.url = api_index_info;
    params.data = {
      searchTimeType: list[pickerIndex].value,
    };
    net.req(params).then((res) => {
      this.setData({
        data: res.data,
        firstLoaidngFlag: false,
      });
    });
  },
  bindPickerChange(e) {
    this.setData({
      pickerIndex: parseInt(e.detail.value),
    });
    this.getWithData();
  },
  handleItemTap(e) {
    let { currentId } = e.currentTarget.dataset;
    switch (currentId) {
      case "1":
        wx.navigateTo({
          url: "/pages/leadslist/leadslist",
        });
        break;
      case "3":
        wx.navigateTo({
          url: "/pages/orderlist/orderlist",
        });
        break;
      case "4":
        wx.navigateTo({
          url: "/pages/myteam/myteam",
        });
        break;
      default:
        break;
    }
  },
  // 用于阻断事件传递
  interdictEventsAction() {},
  bindGoList(e) {
    const { page } = e.currentTarget.dataset;
    let time = "";
    const { list, pickerIndex } = this.data;
    if (pickerIndex !== 4) {
      time = list[pickerIndex].value;
    }
    wx.navigateTo({
      url: `/pages/${page}/${page}?time=${time}`,
    });
  },
  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    if (this.data.showState == 2) {
      this.getWithData();
    }
    wx.stopPullDownRefresh();
  },
});
