const {
  api_order_list
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const util = require('../../utils/util.js');

Page({

  data: {
    isFliter: false,
    pattern: '',
    showAddFlag: false,
    keyWord: "",
    loadMoreFlag: true,
    dataArr: [],
    totalCount: null,
    posterTag: false,
    resultData: {}
  },
  pageData: {
    page: 1,
    limit: 10
  },

  onLoad: function (options) {
    const {
      time
    } = options
    if (time) {
      this.setData({
        [`resultData.createTime`]: JSON.stringify({
          searchTimeType: time,

        }),
        isFliter: true
      })
    }
    this.getData();
  },
  onReady: function () {
    wx.setNavigationBarTitle({
      title: '订单'
    })
    wx.setBackgroundColor({
      backgroundColorBottom: '#fafafa'
    });
  },
  // 获取数据
  getData(isShowLoading = true) {
    wx.stopPullDownRefresh()
    const { totalCount, dataArr } = this.data
    if ((totalCount && parseInt(totalCount)) === dataArr.length) {
      return false
    }
    let params = {
      url: api_order_list,
      data: {
        page: this.pageData.page,
        limit: this.pageData.limit,
      }
    }
    params.data = Object.assign({}, params.data, this.data.resultData)
    if (this.data.keyWord) {
      params.data.keyWord = this.data.keyWord
    }
    this.setData({
      loadMoreFlag: isShowLoading
    })
    net.req(params).then((res) => {
      this.setData({
        loadMoreFlag: false,
        dataArr: this.pageData.page > 1 ? this.data.dataArr.concat(res.data.list) : res.data.list || [],
        totalCount: res.data.pages.totalCount
      })
    })
  },
  initListCallBack() {
    this.setData({
      totalCount: null,
      showAddFlag: false,
    }, () => {
      this.pageData.page = 1
      this.getData();
    })
  },
  onPullDownRefresh: function () {
    this.setData({
      totalCount: null,
    }, () => {
      this.pageData.page = 1
      this.getData();
    })
  },
  // 加载更多
  onReachBottom: function () {
    this.pageData.page += 1
    this.getData(false)
  },
  // 详情页
  goDetailHandle(options) {
    const {
      item
    } = options.currentTarget.dataset;
    wx.navigateTo({
      url: `/pages/orderdetail/orderdetail?id=${item.id}`
    })
  },


  // 实时搜索
  touchSearch(event) {
    let _this = this;
    clearTimeout(this.timer)
    this.timer = setTimeout(() => {
      _this.searchHandle(event);
    }, 500)
  },
  // 完成搜索
  searchHandle(event) {
    this.setData({
      totalCount: null,
      keyWord: event.detail.value,
    }, () => {
      this.pageData.page = 1
      this.getData();
    })
  },
  getResultDataCallack(data) {
    this.setData({
      totalCount: null,
      resultData: data,
      isFliter: Object.keys(data).length === 0 ? false : true
    }, () => {
      this.pageData.page = 1
      this.getData();
    })
  },


  goFilterHandle() {
    wx.navigateTo({
      url: `/pages/orderfilter/orderfilter?resultData=${JSON.stringify(this.data.resultData)}`
    })
  },
})