const {
  api_search_city
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const util = require('../../utils/util.js');

Page({
  /**
   * 页面的初始数据
   */
  data: {
    cityList: []
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.handleSearchInputChange = util.debounce(this.handleSearchInputChange);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  // 点击关闭按钮
  handleClickClose: function () {
    wx.navigateBack();
  },

  // 输入框的值变化，进行搜索
  handleSearchInputChange(e) {
    let value = e.detail;
    value = value.trim();
    if (value) {
      let params = {};
      params.url = api_search_city;
      params.data = {
        keyword: value
      };
      net.req(params, true).then(res => {
        const { code, data } = res;
        if (parseInt(code) === 0 && data && data.list && Array.isArray(data.list)) {
          this.setData({
            cityList: data.list
          });
        } else {
          this.setData({
            cityList: []
          });
        }
      }, (e) => {
        this.setData({
          cityList: []
        });
      });
    } else {
      this.setData({
        cityList: []
      });
    }
  },

  // 点击搜索结果Item
  handleClickSearchItem(e) {
    const countryCityItem = e.detail.extra;
    const selItem = {
      countryId: countryCityItem.countryId,
      countryName: countryCityItem.countryName,
      cityId: countryCityItem.cityId,
      cityName: countryCityItem.cityName
    }
    let pages = getCurrentPages();
    let prevPage = pages[pages.length - 3];
    if (prevPage && prevPage.route === "pages/leadscollection/leadscollection" && prevPage.getSelectedCountryCity) {
      prevPage.getSelectedCountryCity(selItem);
      wx.navigateBack({
        delta: 2
      });
    }
  }

})