const {
  api_get_country_city
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const util = require('../../utils/util.js');

Page({
  /**
   * 页面的初始数据
   */
  data: {
    isLoading: true,
    citySelectObj: null,
    countrySelectObj: null,
    baseData: null,
    cityData: [],
    hotCity: [],
    scrollTop: 0,
    alphabetData: null,
    toView: ''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.loadData();
  },

  // 加载数据
  loadData() {
    let params = {};
    params.url = api_get_country_city;
    net.req(params, true).then(res => {
      const { code, data } = res;
      this.setData({
        isLoading: false
      });
      this.adapter(data);
    }, (e) => {
      this.setData({
        isLoading: false,
        dataArr: []
      });
    });
  },

  // 选择国家
  selectCountry(e) {
    const {
      countryItem
    } = e.currentTarget.dataset;
    this.refreshData(countryItem);
  },

  refreshData(item) {
    let {
      dataArr
    } = this.data;
    if (item) {
      dataArr.forEach(element => {
        if (element.id === item.id) {
          let alphabetData = [];
          if (element.son) {
            element.son.forEach(element => {
              alphabetData.push(element.header);
            });
            alphabetData = [...new Set(alphabetData)];
            // if (element.hot && element.hot[0] && element.hot[0].citys && element.hot[0].citys.length) {
            //   alphabetData.unshift(element.hot.header);
            // }
          }

          this.setData({
            cityData: element.son || [],
            countrySelectObj: item,
            hotCity: element.hot[0] || [],
            alphabetData: alphabetData
          }, () => {
            this.setData({
              scrollTop: 0
            })
          })
        }
      });
    } else {
      const data = dataArr[0];
      let alphabetData = [];
      if (data.son) {
        data.son.forEach(element => {
          alphabetData.push(element.header);
        });
        alphabetData = [...new Set(alphabetData)];
        // if (data.hot && data.hot[0] && data.hot[0].citys && data.hot[0].citys.length) {
        //   alphabetData.unshift(data.hot.header);
        // }
      }

      this.setData({
        countrySelectObj: data,
        cityData: data.son || [],
        hotCity: data.hot[0] || [],
        alphabetData: alphabetData
      })
    }
  },

  // 选择城市
  selectCity(e) {
    const { cityItem } = e.currentTarget.dataset;
    const selItem = {
      countryId: cityItem.countryId,
      countryName: cityItem.countryName,
      cityId: cityItem.id,
      cityName: cityItem.name
    }
    let eventChannel = this.getOpenerEventChannel();
    eventChannel.emit('selectedCityEvent', selItem);
    wx.navigateBack();
  },

  adapter: function (arr) {
    if (!arr || !Array.isArray(arr) || arr.length === 0) {
      this.setData({
        dataArr: []
      });
      return false;
    }
    this.setData({
      dataArr: arr,
      baseData: arr
    });
    this.refreshData(this.data.countrySelectObj);
  },

  // 点击侧边索引
  tapAlphabetAction(e) {
    let {
      currentItem
    } = e.currentTarget.dataset;
    if (currentItem == this.data.hotCity.header) { // 因为id不能为中文
      currentItem = "RMC";
    }
    this.setData({
      toView: currentItem
    })
  },

  // 点击搜索栏，跳转到搜索页
  handleClickSearchInput() {
    wx.navigateTo({
      url: '/pages/searchCity/searchCity'
    })
  },

  // 点击关闭按钮
  handleClickClose() {
    wx.navigateBack();
  }
})