const {
  api_teamMember_list,
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const util = require('../../utils/util.js');
Page({
  data: {
    loadingFlag: true,
    dataArr: [],
    sourceUserIds: [],
    radioId: "",
    positionType: 1,
    pattern: '',
    checkType: '', // 1单选 2多选
  },
  onLoad: function (options) {
    const { checkType, pattern, radioId, sourceUserIds } = options
    this.getData()
    this.setData({
      pattern: pattern || '',
      checkType: checkType || "",
      radioId: radioId || '',
      sourceUserIds: sourceUserIds ? JSON.parse(sourceUserIds) : [],
      positionType: util.getStorageSync('sourceUserListTag') || 1
    })
  },
  // 获取团队列表
  getData() {
    let params = {
      url: api_teamMember_list
    }
    this.setData({
      loadingFlag: true
    })
    net.req(params).then((res) => {
      if (res && res.data && Array.isArray(res.data)) {
        this.setData({
          loadingFlag: false,
          dataArr: res.data || []
        })
      }
    })
  },
  checkBoxHandle(e) {
    const { currentId } = e.currentTarget.dataset
    let sourceUserIds = this.data.sourceUserIds
    if (sourceUserIds.indexOf(currentId) == -1) {
      sourceUserIds.push(currentId)
    } else {
      sourceUserIds.splice(sourceUserIds.indexOf(currentId), 1)
    }
    this.setData({
      sourceUserIds: sourceUserIds
    })
  },
  sureTap() {
    let pages = getCurrentPages();
    let prevPage = pages[pages.length - 2];
    if (prevPage && prevPage.getSourcePersonCallack) {
      prevPage.getSourcePersonCallack(this.data.sourceUserIds);
      wx.navigateBack();
    }
  },
  resetTap() {
    this.setData({
      sourceUserIds: []
    })
  },
  radioHandle(e) {
    const detail = e.detail
    const { positionType, positionTypeText } = detail
    if (positionType == 1) {
      detail.businessRoleText = positionTypeText
    } else if (positionType == 8) {
      detail.businessRoleText = detail.cooperativeNatureText
    }
    this.setData({
      radioId: detail.id
    })
    const { pattern } = this.data
    let pages = getCurrentPages();
    let prevPage = pages[pages.length - 2];
    if (pattern) {
      // 更换二维码的来源人
      if (prevPage && prevPage.posterHandle) {
        prevPage.posterHandle(pattern, detail);
      }
    } else {
      if (prevPage && prevPage.getSourcePersonCallack) {
        prevPage.getSourcePersonCallack(detail);
      }
    }
    wx.navigateBack();
  },
})